
Smart Proxy - Bug #17890

PowerDNS smartproxy fails because of AAAA/IPV6 record failure

01/02/2017 09:06 AM - El Joppa

Status: Resolved   

Priority: Normal   

Assignee: Ewoud Kohl van Wijngaarden   

Category: DNS   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.14.0

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

ii  foreman-proxy                        1.14.0~rc2-1                    all          RESTful proxies for DNS, DHCP, TFTP, and Puppet

ii  ruby-smart-proxy-dns-powerdns        0.2.1-1                         all          PowerDNS DNS provider plugin for Foreman's smart proxy

Ubuntu 16.04.

Are there any possibility to not manage these AAAA records?

E, [2017-01-02T14:03:38.995441 ] ERROR -- : undefined method `create_aaaa_record' for #<Proxy::Dns

::Powerdns::Backend::Mysql:0x000000027fb5c8>

Did you mean?  create_a_record

               create_record

               create_cname_record

               create_ptr_record

D, [2017-01-02T14:03:38.995584 ] DEBUG -- : undefined method `create_aaaa_record' for #<Proxy::Dns

::Powerdns::Backend::Mysql:0x000000027fb5c8>

Did you mean?  create_a_record

               create_record

               create_cname_record

               create_ptr_record (NoMethodError)

/usr/share/foreman-proxy/modules/dns/dns_api.rb:28:in `block in <class:Api>'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1611:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1611:in `block in compile!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:975:in `block (3 levels) in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:994:in `route_eval'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:975:in `block (2 levels) in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1015:in `block in process_route'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1013:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1013:in `process_route'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:973:in `block in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:972:in `each'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:972:in `route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1085:in `block in dispatch!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `block in invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1082:in `dispatch!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:907:in `block in call!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `block in invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:907:in `call!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:895:in `call'

/usr/lib/ruby/vendor_ruby/rack/commonlogger.rb:33:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:219:in `call'

/usr/share/foreman-proxy/lib/proxy/log.rb:88:in `call'

/usr/share/foreman-proxy/lib/proxy/request_id_middleware.rb:9:in `call'
/usr/lib/ruby/vendor_ruby/rack/protection/xss_header.rb:18:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/path_traversal.rb:16:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/json_csrf.rb:18:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/base.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/base.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/frame_options.rb:31:in `call'

/usr/lib/ruby/vendor_ruby/rack/nulllogger.rb:9:in `call'

/usr/lib/ruby/vendor_ruby/rack/head.rb:13:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/show_exceptions.rb:25:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:182:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:2013:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1487:in `block in call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1787:in `synchronize'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1487:in `call'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:66:in `block in call'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:50:in `each'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:50:in `call'

/usr/lib/ruby/vendor_ruby/rack/builder.rb:153:in `call'

/usr/lib/ruby/vendor_ruby/rack/handler/webrick.rb:88:in `service'

/usr/lib/ruby/2.3.0/webrick/httpserver.rb:140:in `service'

/usr/lib/ruby/2.3.0/webrick/httpserver.rb:96:in `run'

/usr/lib/ruby/2.3.0/webrick/server.rb:296:in `block in start_thread'

History

#1 - 01/02/2017 08:29 PM - Ewoud Kohl van Wijngaarden

- Project changed from Foreman to Smart Proxy

- Category set to DNS

- Status changed from New to Feedback

- Assignee set to Ewoud Kohl van Wijngaarden

I released version 0.3.0 which should have fixed this issue, but it was only added to the 1.14 repo a few hours ago. Can upgrade to the latest version

and verify it works?

#2 - 01/03/2017 05:04 AM - El Joppa

0.3.0 fixed AAAA records. Now i have some issues with PTR:

W, [2017-01-03T09:51:21.425010 ]  WARN -- : Proxy::Dns::Record#ptr_record_conflicts with a non-ptr record para

meter has been deprecated and will be removed in future versions of Smart-Proxy.

                      Please use ::Proxy::Dns::Record#ptr_record_conflicts('101.212.58.216.in-addr.arpa') form

at instead.

E, [2017-01-03T09:51:21.441508 ] ERROR -- : Unable to determine zone. Zone must exist in PowerDNS.

D, [2017-01-03T09:51:21.441569 ] DEBUG -- : Unable to determine zone. Zone must exist in PowerDNS. (Proxy::Dns

::Error)

/usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns/backend/mysql.rb:29:in `get_zone'

/usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns/dns_powerdns_main.rb:61:in `do_create'

/usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns/dns_powerdns_main.rb:56:in `create_ptr_record'

/usr/share/foreman-proxy/modules/dns/dns_api.rb:33:in `block in <class:Api>'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1611:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1611:in `block in compile!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:975:in `block (3 levels) in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:994:in `route_eval'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:975:in `block (2 levels) in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1015:in `block in process_route'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1013:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1013:in `process_route'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:973:in `block in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:972:in `each'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:972:in `route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1085:in `block in dispatch!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `block in invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1082:in `dispatch!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:907:in `block in call!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `block in invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `invoke'
/usr/lib/ruby/vendor_ruby/sinatra/base.rb:907:in `call!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:895:in `call'

/usr/lib/ruby/vendor_ruby/rack/commonlogger.rb:33:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:219:in `call'

/usr/share/foreman-proxy/lib/proxy/log.rb:88:in `call'

/usr/share/foreman-proxy/lib/proxy/request_id_middleware.rb:9:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/xss_header.rb:18:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/path_traversal.rb:16:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/json_csrf.rb:18:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/base.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/base.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/frame_options.rb:31:in `call'

/usr/lib/ruby/vendor_ruby/rack/nulllogger.rb:9:in `call'

/usr/lib/ruby/vendor_ruby/rack/head.rb:13:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/show_exceptions.rb:25:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:182:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:2013:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1487:in `block in call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1787:in `synchronize'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1487:in `call'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:66:in `block in call'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:50:in `each'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:50:in `call'

/usr/lib/ruby/vendor_ruby/rack/builder.rb:153:in `call'

/usr/lib/ruby/vendor_ruby/rack/handler/webrick.rb:88:in `service'

/usr/lib/ruby/2.3.0/webrick/httpserver.rb:140:in `service'

/usr/lib/ruby/2.3.0/webrick/httpserver.rb:96:in `run'

/usr/lib/ruby/2.3.0/webrick/server.rb:296:in `block in start_thread'

 Im not sure which zone it is looking for though, i have 0.0.0.10.in-addr.arpa. defined in PowerDNS.

#3 - 01/03/2017 05:58 AM - El Joppa

My bad, the node is not in the specified subnet.

#4 - 01/03/2017 06:17 AM - El Joppa

Rolf Larsen wrote:

0.3.0 fixed AAAA records. Now i have some issues with PTR:

[...]

Im not sure which zone it is looking for though, i have 0.0.0.10.in-addr.arpa. defined in PowerDNS.

 Allthough trying to rebuild a node in the subnet i get the same message:

W, [2017-01-03T11:15:03.178794 ]  WARN -- : Proxy::Dns::Record#ptr_record_conflicts with a non-ptr record para

meter has been deprecated and will be removed in future versions of Smart-Proxy.

                      Please use ::Proxy::Dns::Record#ptr_record_conflicts('101.212.58.216.in-addr.arpa') form

at instead.

E, [2017-01-03T11:15:03.181339 ] ERROR -- : Unable to determine zone. Zone must exist in PowerDNS.

D, [2017-01-03T11:15:03.181413 ] DEBUG -- : Unable to determine zone. Zone must exist in PowerDNS. (Proxy::Dns

::Error)

/usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns/backend/mysql.rb:29:in `get_zone'

/usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns/dns_powerdns_main.rb:61:in `do_create'

/usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns/dns_powerdns_main.rb:56:in `create_ptr_record'

/usr/share/foreman-proxy/modules/dns/dns_api.rb:33:in `block in <class:Api>'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1611:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1611:in `block in compile!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:975:in `block (3 levels) in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:994:in `route_eval'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:975:in `block (2 levels) in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1015:in `block in process_route'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1013:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1013:in `process_route'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:973:in `block in route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:972:in `each'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:972:in `route!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1085:in `block in dispatch!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `block in invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1082:in `dispatch!'
/usr/lib/ruby/vendor_ruby/sinatra/base.rb:907:in `block in call!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `block in invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `catch'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1067:in `invoke'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:907:in `call!'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:895:in `call'

/usr/lib/ruby/vendor_ruby/rack/commonlogger.rb:33:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:219:in `call'

/usr/share/foreman-proxy/lib/proxy/log.rb:88:in `call'

/usr/share/foreman-proxy/lib/proxy/request_id_middleware.rb:9:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/xss_header.rb:18:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/path_traversal.rb:16:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/json_csrf.rb:18:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/base.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/base.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/rack/protection/frame_options.rb:31:in `call'

/usr/lib/ruby/vendor_ruby/rack/nulllogger.rb:9:in `call'

/usr/lib/ruby/vendor_ruby/rack/head.rb:13:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/show_exceptions.rb:25:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:182:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:2013:in `call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1487:in `block in call'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1787:in `synchronize'

/usr/lib/ruby/vendor_ruby/sinatra/base.rb:1487:in `call'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:66:in `block in call'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:50:in `each'

/usr/lib/ruby/vendor_ruby/rack/urlmap.rb:50:in `call'

/usr/lib/ruby/vendor_ruby/rack/builder.rb:153:in `call'

/usr/lib/ruby/vendor_ruby/rack/handler/webrick.rb:88:in `service'

/usr/lib/ruby/2.3.0/webrick/httpserver.rb:140:in `service'

/usr/lib/ruby/2.3.0/webrick/httpserver.rb:96:in `run'

/usr/lib/ruby/2.3.0/webrick/server.rb:296:in `block in start_thread'

I, [2017-01-03T11:15:03.183083 ]  INFO -- : 10.0.70.34 - - [03/Jan/2017:11:15:03 +0000] "POST /dns/ HTTP/1.1" 

400 54 0.0051

#5 - 01/03/2017 07:10 AM - Ewoud Kohl van Wijngaarden

I already noticed that the logging was fairly minimal and I really need to improve on that. My guess is that it's trying to create an IPv6 reverse DNS

record, possibly because of #17895.

If you're on IRC we can try to debug it there together, otherwise we can try it here.

#6 - 01/03/2017 07:25 AM - Ewoud Kohl van Wijngaarden

I created https://github.com/theforeman/smart_proxy_dns_powerdns/pull/30 which you can apply locally:

cd /usr/lib/ruby/vendor_ruby/smart_proxy_dns_powerdns && curl https://patch-diff.githubusercontent.com/raw/the

foreman/smart_proxy_dns_powerdns/pull/30.patch | patch -p1

service foreman-proxy restart

#7 - 01/03/2017 08:16 AM - Ewoud Kohl van Wijngaarden

- Status changed from Feedback to Resolved

Confirmed (on IRC) that the logging patch works and also that the last error was a legitimate error since the zone did not exist. After creating it,

everything worked as intended.
